
function dbiScriptApplication() {

  var dbType = 0; // 0 - Access, 1 - Oracle, 2 - SQL Server, 3 - MySQL, 4 - PostgreSQL, 5 - DB2, 6 - SQL Anywhere

//  app.dbiScriptProperties.rebuildDatabase = true;
  app.dbiScriptProperties.dataConfig = "../data/clinic"+["","Oracle","SQLServer","MySQL","Postgres","DB2","SQLAnywhere"][dbType]+".cfg"
//  app.dbiScriptProperties.allowDeleteWithoutConfirm = false;
//  app.dbiScriptProperties.appendTimeZoneToTitle = true;
//  app.dbiScriptProperties.users.firstName.isRequired = false;
//  app.dbiScriptProperties.users.lastName.isRequired = false;
  app.dbiScriptProperties.tables.auditColumns.create = true;
//  app.dbiScriptProperties.dataTables.autoMinimize = true;
  app.dbiScriptProperties.dataTables.deletes.confirm.isUniversal = true;
  app.dbiScriptProperties.dataTables.fetchAll = false;
  app.dbiScriptProperties.dataTables.handleLostLock = 0;
//  app.dbiScriptProperties.dataTables.rows.drilldown.style.caption.display.all = {background:"blue"};
//  app.dbiScriptProperties.dataTables.rows.drilldown.style.display.all = {background:"blue"};
//  app.dbiScriptProperties.dataTables.rows.drilldown.style.caption.edit = {even:{background:"red"},odd:{background:"green"},selected:{background:"blue"}};
//  app.dbiScriptProperties.dataTables.rows.drilldown.style.edit = {even:{background:"red"},odd:{background:"green"},selected:{background:"blue"}};
//  app.dbiScriptProperties.dataTables.rows.drilldown.style.all = {background:"magenta"};
  app.dbiScriptProperties.dataTables.windows.sort.fieldListOrder = "alphabetical"; //"physical";
  app.dbiScriptProperties.dataTables.fields.boolean.nullIsFalse = false;
  app.dbiScriptProperties.dataTables.fields.boolean.falseIsBlank = false;
  app.dbiScriptProperties.dataTables.fields.boolean.values = [0,1]; // Oracle & DB2 don't support a true boolean data type - other dbs may use non-boolean fields to store boolean data
//  app.dbiScriptProperties.dataTables.fields.datetime.forceCase = "UPPER";
  app.dbiScriptProperties.dataTables.fields.datetime.storeUTC = true;
//  app.dbiScriptProperties.dataTables.fields.datetime.showTime = true;
  app.dbiScriptProperties.dataTables.fields.datetime.showSeconds = false;
  app.dbiScriptProperties.dataTables.fields.datetime.showTimeZone = false;
//  app.dbiScriptProperties.dataTables.fields.drilldown.style.display = {even:{background:"red"},odd:{background:"green"},selected:{background:"blue"}};
  app.dbiScriptProperties.dataTables.fields.email.cc = "you@mydomain.com";
  app.dbiScriptProperties.dataTables.fields.email.bcc = "them@mydomain.com";
  app.dbiScriptProperties.dataTables.fields.email.subject = "Test";
  app.dbiScriptProperties.dataTables.fields.email.body = "This is a test.";
//  app.dbiScriptProperties.dataTables.fields.fileVault.forceCase = "UPPER";
  app.dbiScriptProperties.dataTables.fields.iconlist.type = "dynamic";
//  app.dbiScriptProperties.dataTables.fields.inline.style.display = {even:{background:"red"},odd:{background:"green"},selected:{background:"blue"}};
//  app.dbiScriptProperties.dataTables.fields.inline.editSize = ["columnWidth","fieldWidth"][0];
//  app.dbiScriptProperties.dataTables.fields.inline.style.edit = {even:{background:"red"},odd:{background:"green"},selected:{background:"blue"}};
  app.dbiScriptProperties.dataTables.fields.memo.rows = 4;
  app.dbiScriptProperties.dataTables.fields.memo.isSortable = true;
  app.dbiScriptProperties.dataTables.fields.memoPreview.displaySize = 30
  app.dbiScriptProperties.dataTables.fields.money.allowSpinNegative = true
  app.dbiScriptProperties.dataTables.fields.money.decimals = 2;
//  app.dbiScriptProperties.dataTables.fields.money.editSize = 6;
  app.dbiScriptProperties.dataTables.fields.money.hasSpinner = true;
  app.dbiScriptProperties.dataTables.fields.number.allowSpinNegative = true;
//  app.dbiScriptProperties.dataTables.fields.number.decimals = 2;
//  app.dbiScriptProperties.dataTables.fields.number.editSize = 4;
  app.dbiScriptProperties.dataTables.fields.number.hasSpinner = true
  app.dbiScriptProperties.dataTables.fields.password.minStrength = 50;
  app.dbiScriptProperties.dataTables.fields.picklist.allowNew = false;
  app.dbiScriptProperties.dataTables.fields.picklist.displayRows = 4;
  app.dbiScriptProperties.dataTables.fields.picklist.editRows = 4;
  app.dbiScriptProperties.dataTables.fields.picklist.fixedWidth = true;
  app.dbiScriptProperties.dataTables.fields.picklist.width = 20;
  app.dbiScriptProperties.dataTables.fields.picklist.type = "string";
  app.dbiScriptProperties.dataTables.fields.quickpick.allowNew = false;
//  app.dbiScriptProperties.dataTables.fields.quickpick.forceCase = "UPPER";
  app.dbiScriptProperties.dataTables.fields.quickpick.inputSize = 8;
  app.dbiScriptProperties.dataTables.fields.quickpick.isAsynchronous = true;
//  app.dbiScriptProperties.dataTables.fields.quickpick.selectSize = 5;
  app.dbiScriptProperties.dataTables.fields.radio.isRequired = false;
  app.dbiScriptProperties.dataTables.fields.reference.inputSize = 12;
  app.dbiScriptProperties.dataTables.fields.reference.isSortExtended = false;
  app.dbiScriptProperties.dataTables.fields.reference.type = "quickpop";
  app.dbiScriptProperties.dataTables.fields.select.allowNew = false;
//  app.dbiScriptProperties.dataTables.fields.select.forceCase.description = "UPPER";
//  app.dbiScriptProperties.dataTables.fields.string.forceCase = "UPPER";
  app.dbiScriptProperties.dataTables.fields.string.soundex.autoCreate = false;
  app.dbiScriptProperties.dataTables.fields.string.soundex.autoCreateMinColWidth = 4;
  app.dbiScriptProperties.dataTables.fields.string.soundex.autoCreateMaxColWidth = 25;
  app.dbiScriptProperties.dataTables.fields.string.soundex.create = false;
  app.dbiScriptProperties.dataTables.fields.string.soundex.extension = "_sx";
  app.dbiScriptProperties.dataTables.fields.string.soundex.triggers.create = true;
  app.dbiScriptProperties.dataTables.fields.treeview.allowNew = false;
//  app.dbiScriptProperties.dataTables.fields.treeview.forceCase = "UPPER";
  app.dbiScriptProperties.dataTables.fields.treeview.displayPath = false;
  app.dbiScriptProperties.dataTables.fields.treeview.pathSeparator = " / ";

  app.addDefinitionTable("dfnmst",["descr",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],["srcdbf",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],["srcfld",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],{additionalFields:[["code",["varchar(5)","varchar2(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)"][dbType]]],dataOrder:0/* 0 - descr asc (default), 1 - descr desc*/,primaryKey:"pid"});
  app.addDefinitionTable("icd9mst",["descr",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],{additionalFields:[["code",["varchar(5)","varchar2(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)"][dbType]]],dataOrder:0/* 0 - descr asc (default), 1 - descr desc*/,primaryKey:"pid"});
  app.addDefinitionTable("prcmst",["descr",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],{additionalFields:[["code",["varchar(5)","varchar2(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)"][dbType]]],dataOrder:0/* 0 - descr asc (default), 1 - descr desc*/,primaryKey:"pid"});
  app.addFileTable("filemst","srcid",["filename",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],["userid",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],["action",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],["occurred",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],["srcdbf",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],["srcfld",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],{primaryKey:"pid"});
  app.addLinkTable("linkmst","parentid","childid",["order",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],["descr",["varchar(50)","varchar2(50)","varchar(50)","varchar(50)","varchar(50)","varchar(50)","varchar(50)"][dbType]]);
  app.addPhotoTable("photomst","srcid",["filename",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],["descr",["varchar(255)","varchar2(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)","varchar(255)"][dbType]],["order",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],["srcdbf",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],["srcfld",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],{primaryKey:"pid"});

  var o = app.gui.appendDataTable("patient","Patients","Patient",{drop:false});
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
//  o.dbiScriptProperties.fieldList = "lname,fname,mi";
  o.dbiScriptProperties.fields.boolean.nullIsFalse = false;
  o.dbiScriptProperties.fields.boolean.falseIsBlank = false;
  o.dbiScriptProperties.fields.email.cc = "me@mydomain.com";
  o.dbiScriptProperties.fields.email.bcc = "them@mydomain.com";
  o.dbiScriptProperties.fields.email.subject = "Test";
  o.dbiScriptProperties.fields.email.body = "This is a test.";
  o.dbiScriptProperties.fields.inline.editSize = ["columnWidth","fieldWidth"][0];
//  o.dbiScriptProperties.fields.memo.rows = 8;
//  o.appendRecordState("retired","",{allowNull:false/*,iconPath:"path",icons:["icon1.gif","icon2.gif", ... ,"iconx.gif"]*/}); // optional: image or array of images for states, default: two states (with optional null) - green led, red led(, blank)
//  o.appendIconlist("icons","Icons",["linkmst","PATIENT ICONS"],"images",["a.png","b.png","c.png","d.png"],{type:"dynamic"});
  o.appendRowState("inactv")
  o.appendIconlist("icons","Icons","images",["a.png","b.png","c.png","d.png"]);
  o.appendSelect(["sal",["varchar(4)","varchar2(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)"][dbType]],"Sal",{Mr:"Mr",Mrs:"Mrs",Ms:"Ms",Miss:"Miss",Dr:"Dr",Rev:"Rev"});//,{isRequired:true});
  o.appendData([["fname","fnames"],["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]/*,{drop:false,update:true,indexed:true,notNull:true}*/],"First Name");
  o.appendData(["mi",["varchar(1)","varchar2(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)"][dbType]],"MI",{forceCase:"UPPER"});
  o.appendData(["lname",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Last Name");
  o.appendSelect(["suffix",["varchar(3)","varchar2(3)","varchar(3)","varchar(3)","varchar(3)","varchar(3)","varchar(3)"][dbType]],"Suffix",{"Jr":"Jr","Sr":"Sr",II:"II",III:"III",IV:"IV"});
//  o.groupFields("name","Name","fname","mi","lname");
  o.appendData(["address1",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],"Address",{isUnique:true});
  o.appendData(["address2",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],"Address ...");
  o.appendQuickpick(["city",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"City",U,{/*isAsynchronous:true*/});
  o.appendQuickpick(["state",["varchar(2)","varchar2(2)","varchar(2)","varchar(2)","varchar(2)","varchar(2)","varchar(2)"][dbType]],"State"/*,{default:"AZ"}*/);
  o.appendData(["zip",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Zip");
//  o.appendMemoPreview("notes","Notes",{displaySize:20});
//  o.appendButton("button1","",{caption:"Map"});
  o.appendData(["stock",["varchar(4)","varchar2(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)"][dbType]],"Stock Symbol");
  o.appendWebServiceRequest("stockPrice","Stock Price","http://quote.yahoo.com/d/quotes.csv",{allowManualRefresh:true,httpMethod:"GET",serverErrorDisplay:"console",textAlign:"right"}); // note: Yahoo returns the web service data in csv format but since we're only receiving a single value, we can use the "string" (default) WebServiceRequest type
  o.appendPhotoAlbum("photo1","Patient Album 1","../data/images/clinic/patient",["photomst","PATIENT","PHOTO1"]);
  o.appendPhotoAlbum("photo2","Patient Album 2","../data/images/clinic/patient1",["photomst","PATIENT","PHOTO2"]);
//  o.drilldown.appendPicklist("testpicklist","Test Picklist",["dfnmst","DRMST","CPSPECID"],["linkmst","PATIENT CPSPECID"],{allowNew:true,displayRows:4/* <- type "table": 2-10, default 4*/,editRows:5/* <- type "table": 2-10, default 4*/,fixedWidth:true/* <- type "table": default false */,headings:["Optional Heading One","Optional Heading Two"],maxItems:99,/* dataOrder:1,"descr desc,code",*/type:"string",width:200/* <- type "table":100-500, default 200*/}); // dataOrder: not specified - default, by definition table, 0 - descr asc, 1 - descr desc, 2 - list by descr asc, selected by link table order field, 3 - list by descr desc, selected by link table order field
//  o.drilldown.appendBoolean("test","Test Boolean");
  o.drilldown.appendData(["ssn",["varchar(9)","varchar2(9)","varchar(9)","varchar(9)","varchar(9)","varchar(9)","varchar(9)"][dbType]],"SSN",{inputMask:"[999-999-999]"});
  o.drilldown.appendRadio(["gender",["varchar(1)","varchar2(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)"][dbType]],"Gender",{M:"Male",F:"Female"},{isRequired:true});
  o.drilldown.appendData(["dob",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date of Birth");//,{hasSpinner:false,showTime:true,showSeconds:true,showTimeZone:true,storeUTC:false});
  o.drilldown.appendAge("dob","Age");
  o.drilldown.appendBoolean("billptonly","Bill Patient Only");
  o.drilldown.appendBoolean("sndstmnt","Send Statement");
  o.drilldown.appendData(["hphone",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],["Home","Home Phone Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData(["cellphone",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],["Cell","Cell Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData(["fax",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],["Fax","Fax Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.groupFields("phonenumbers","Phone Numbers","hphone","cellphone","fax");
  o.drilldown.appendBoolean("asig",["Assignment","Assignment Signature"]);
  o.drilldown.appendBoolean("rs",["Release","Release Signature"]);
  o.drilldown.groupFields("sigs","Signatures","asig","rs");
  o.drilldown.appendReference("sdrmstid",["Primary","Primary Physician"],"sdrmst",["lname","fname","mi"],{isRequired:false,type:"poptable"/* "quickpop", "quickpick", "poptable" */});
  o.drilldown.appendReference("rdrmstid",["Referring","Referring Physician"],"rdrmst",["lname","fname","mi"]);
  o.drilldown.groupFields("drs","Physicians","sdrmstid","rdrmstid");
  o.drilldown.appendSelect("statusid","Marital Status",["dfnmst","PATIENT","STATUSID"],{code:"code"});
  o.drilldown.appendSelect("studentid","Student Status",["dfnmst","PATIENT","STUDENT"],{code:"code"});
  o.drilldown.appendSelect("finclassid","Financial Class",["dfnmst","PATIENT","FINCLASSID"],{code:"code"});
  o.drilldown.appendReference("attorneyid","Attorney","attorney",["lname","fname","mi"]);
  o.drilldown.appendSelect("restypeid","Residence",["dfnmst","PATIENT","RESTYPEID"],{allowNew:true,code:"code",dataOrder:"code asc",isRequired:true});
  o.drilldown.appendSelect("mailcodeid","Mail Code",["dfnmst","PATIENT","MAILCODEID"],{allowNew:true,code:"code",dataOrder:"code asc",isRequired:true});
  o.drilldown.appendSelect("npsrcid","Source",["dfnmst","PATIENT","NPSRCID"],{isRequired:true,code:"code",allowNew:true});
  o.drilldown.appendSelect("relatetoid","Injury Related To",["dfnmst","PATIENT","RELATETOID"],{allowNew:true,code:"code",isRequired:true});
  o.drilldown.appendData(["consdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"First Consultation");
  o.drilldown.appendData(["xraydttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Initial X-Ray");
  o.drilldown.appendData(["injurydttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Injury Illness");
  o.drilldown.appendData(["ssympdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Similar Symptom");
  o.drilldown.appendData(["lstseendttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Last Seen");
  o.drilldown.appendData(["lstmensdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Last Menstruation");
  o.drilldown.appendData(["retiredttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Retirement");
  o.drilldown.appendData(["collectdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"To Collections");
  o.drilldown.appendData(["inactvdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Inactive");
  o.drilldown.appendData(["deathdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Death");
  o.drilldown.appendSelect("countryid","Country",["dfnmst","COUNTRY","COUNTRY"],{allowNew:true});
  o.drilldown.appendSelect("stateid","State",["dfnmst","STATE","STATE"],["countryid","linkmst","COUNTRY -> STATE"],{allowNew:true});
  o.drilldown.appendReference("refpatientid","Referred By","patient",["lname","fname","mi"]);
  o.drilldown.appendTreeview("itemid","Tree Item",["dfnmst","PATIENT","TV1"],["linkmst","PATIENT TV1"],{allowDeleteLinkedItems:true,allowNew:true/*,displayPath:true*/,windowHeight:600,windowWidth:400});
  o.drilldown.appendFileVault("file","Patient File",["filemst","PATIENT","FILE1"],"../data/files/clinic/patient");
//  o.drilldown.appendMoveButton("copy","Backup This Record","patient_copy");
  o.drilldown.appendPicklist("icd9ids","Diagnosis","icd9mst",["linkmst","PATIENT ICD9ID"],{allowNew:true,dataOrder:"asc",headings:["One","Two"]});//,type:"table"});
  o.drilldown.appendData(["notes",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Notes");
  o.drilldown.appendCopyButton("backup","Backup Patient Data","patient_copy")
//  o.drilldownCustomLayoutHTML = "<TABLE><TR><TD colspan=3 field=testpicklist></TD></TR><TR><TD field=sdrmstid></TD><TD field=rdrmstid></TD><TD field=attorneyid></TD></TR><TR><TD field=gender></TD><TD field=lstmensdttm></TD></TR><TR><TD field=dob></TD><TD field=dob_age></TD></TD></TR><TR><TD field=mailcodeid></TD><TD field=npsrcid></TD><TD field=relatetoid></TD></TR><TR><TD field=statusid></TD><TD field=studentid></TD><TD field=refpatientid></TD></TR><TR><TD colspan=3 field=notes></TD></TR></TABLE>";

  o = app.gui.appendDataTable("insmst","Insurance Companies","Insurance Company");
  o.dataOrder = "name";
  o.appendData(["name",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],"Company Name");
  o.appendSelect("typeid","Type",["dfnmst","INSMST","TYPEID"],{allowNew:true,code:"code",isRequired:true});
  o.appendData(["contact",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Contact");
  o.appendData(["phone",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Phone Number",{inputMask:"![(999)] [999-9999]"});
  o.appendData(["pext",["varchar(5)","varchar2(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)"][dbType]],"Ext");
  o.appendMemoPreview("notes","Notes");
  o.drilldown.appendData(["address1",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],["","Address"]);
  o.drilldown.appendData(["address2",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],["","Address ..."],{editSize:"fieldWidth"});
  o.drilldown.appendData(["city",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"City");
  o.drilldown.appendData(["state",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"State");
  o.drilldown.appendData(["zip",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Zip");
  o.drilldown.groupFields("address","Address","address1","address2","city","state","zip");
  o.drilldown.appendData(["fax",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Fax Number",{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData(["cellphone",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Cell Phone",{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendEmail(["email",["varchar(30)","varchar2(30)","varchar(30)","varchar(30)","varchar(30)","varchar(30)","varchar(30)"][dbType]],"Email Address");
  o.drilldown.appendURL(["website",["varchar(30)","varchar2(30)","varchar(30)","varchar(30)","varchar(30)","varchar(30)","varchar(30)"][dbType]],"Website");
  o.drilldown.appendData("ocnano","OCNA #");
  o.drilldown.appendRadio(["bmethod",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],"Billing Method",{1:"Electronic",2:"HCFA",3:"Invoice",4:"UB92"});
  o.drilldown.appendRadio(["paysystem",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],"Payment System",{1:"Fee For Service",2:"Capitated"});
  o.drilldown.appendData(["payorid",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Payor ID");
  o.drilldown.appendData(["claimoffice",["varchar(4)","varchar2(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)","varchar(4)"][dbType]],"Claim Office");
  o.drilldown.appendReference("submitterid","Submitter","submtmst","name");
  o.drilldown.appendSelect("btypeid","Billing Type",["dfnmst","IBTYPEMST","BTYPEMSTID"],{allowNew:true,code:"code",isRequired:true});
  o.drilldown.appendData(["notes",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Notes",{rows:5});

  o = app.gui.appendDataTable("sdrmst","MDs","MD");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData(["fname",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],"First Name");
  o.appendData(["mi",["varchar(1)","varchar2(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)"][dbType]],"MI",{forceCase:"UPPER"});
  o.appendData(["lname",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Last Name");
  o.drilldown.appendPicklist("specialtyids","Specialties",["dfnmst","DRMST","CPSPECID"],["linkmst","SDRMST CPSPECID"],{allowNew:true,displayRows:4/* <- type "table": 2-10, default 4*/,editRows:5/* <- type "table": 2-10, default 4*/,fixedWidth:false/* <- type "table": default false */,headings:["Optional Heading One","Optional Heading Two"],maxItems:5,/* dataOrder:1,"descr desc,code",*//*type:"table",*/width:200/* <- type "table":100-500, default 200*/}); // dataOrder: not specified - default, by definition table, 0 - descr asc, 1 - descr desc, 2 - list by descr asc, selected by link table order field, 3 - list by descr desc, selected by link table order field

  o = app.gui.appendDataTable("rdrmst","Referring MDs","Referring MD");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData(["fname",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],"First Name");
  o.appendData(["mi",["varchar(1)","varchar2(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)"][dbType]],"MI",{forceCase:"UPPER"});
  o.appendData(["lname",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Last Name");
//  o.groupFields("name","Name","lname","fname","mi");

  o = app.gui.appendDataTable("attorney","Attorneys","Attorney");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData(["fname",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],"First Name");
  o.appendData(["mi",["varchar(1)","varchar2(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)","varchar(1)"][dbType]],"MI",{forceCase:"UPPER"});
  o.appendData(["lname",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"Last Name");
  o.appendData(["address1",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],"Address");
  o.appendData(["address2",["varchar(35)","varchar2(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)","varchar(35)"][dbType]],"Address ...");
  o.appendData(["city",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"City");
  o.appendData(["state",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"State");
  o.appendData(["zip",["varchar(10)","varchar2(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)","varchar(10)"][dbType]],"Zip");

  o = app.gui.appendDataTable("submtmst","Submitters","Submitter");
  o.appendData("name","Company Name");
  o.appendData("phone","Phone Number",{inputMask:"![(999)] [999-9999]"});
  o.appendURL("website","Website");

  o = app.gui.appendDataTable("policymst","Insurance Policies","Insurance Policy","insmst:insmstid");
  o.appendData(["insgroup",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"Insurance Group");
  o.appendData(["termdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Term");
  o.appendReference("patientid","Policy Owner","patient",["lname","fname","mi"]);
  o.appendData(["contract",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"Contract");
  o.appendSelect("policytypeid","Policy Type",["dfnmst","POLICYMST","POLICYTYPEID"],{allowNew:true,code:"code",isRequired:true});
  o.appendData(["coverage",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Service Code");
  o.appendMoney("deduct","Deductible");
  o.appendMoney("deductelse","Used Deductible");
  o.appendAggregateMoney("total","Total","tranprc","SUM(chargeins+chargepat)");
  o.drilldown.appendData(["copaylvl1",["decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)"][dbType]],["Initial","Initial Copay"]);
  o.drilldown.appendSelect(["copaylvl1type","char(1)"],["","Initial Copay Type"],{$:"Dollars","%":"Percent"});
  o.drilldown.appendData(["copaylvl2visits",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],["After [---] visits","Number of Visits Before Secondary Copay"]);
  o.drilldown.appendData(["copaylvl2",["decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)","decimal(19,4)"][dbType]],["","Secondary Copay"]);
  o.drilldown.appendSelect(["copaylvl2type","char(1)"],["","Secondary Copay Type"],{$:"Dollars","%":"Percent"});
  o.drilldown.groupFields("group1","Copay","copaylvl1","copaylvl1type","copaylvl2visits","copaylvl2","copaylvl2type");

  o = app.gui.appendDataTable("patpolicymst","Patient Policies","Patient Policy","patient:patientid,policymst:policymstid",0,1);
  o.appendRadio(["typeid",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],"Type",{1:"Primary",2:"Secondary",3:"Tertiary",4:"Archive"});
  o.appendSelect("relationid","Relation to Policy Owner",["dfnmst","POLICYMST","RELATIONID"],{allowNew:true,code:"code",isRequired:true});

  o = app.gui.appendDataTable("trandtl","Transactions","Transaction","patpolicymst:patpolicymstid");
  o.dbiScriptProperties.dataOrder = "servfrdttm desc";
  o.pageSize = 5;
  o.appendData(["servfrdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date Opened",{isUniqueWithinForeignKeys:true});
  o.appendData(["claimno",["varchar(5)","varchar2(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)","varchar(5)"][dbType]],"Claim #");
  o.appendData(["fileno",["varchar(3)","varchar2(3)","varchar(3)","varchar(3)","varchar(3)","varchar(3)","varchar(3)"][dbType]],"File #");
  o.appendData(["contract",["varchar(20)","varchar2(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)","varchar(20)"][dbType]],"Contract #");
  o.appendData(["coverage",["varchar(25)","varchar2(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)","varchar(25)"][dbType]],"Coverage");
  o.appendBoolean("aa","AA");//,{falseIsBlank:true,values:[0,1]});
  o.appendAggregateMoney("total","Total","tranprc","SUM(tranprc.chargeins+tranprc.chargepat)","tranprc.servtodttm >= @startOf2012::servtodttm AND tranprc.servtodttm < @startOf2013::servtodttm");
//  o.appendMoveButton("move","Archive Record","trandtl_copy",[["tranprc","tranprc_copy"]]);
  o.appendMemoPreview("notes","Notes",{displaySize:30});
  o.drilldown.appendData(["notes",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Notes");

  o = app.gui.appendDataTable("trandtl2","Disability","Disability","trandtl:trandtlid",0,1,{primaryKey:"trandtlid"});
  o.appendData(["totaldisabilityfrom",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Total Disability From");
  o.appendData(["totaldisabilityto",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Total Disability To");
  o.appendData(["partialdisabilityfrom",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Partial Disability From");
  o.appendData(["partialdisabilityto",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Partial Disability To");
  o.appendData(["offworkfrom",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Off Work From");
  o.appendData(["offworkto",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Off Work To");

  o = app.gui.appendDataTable("trandtla","Ambulance","Ambulance","trandtl:trandtlid",0,1);
  o.appendData(["miles",["decimal(5,1)","number(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)"][dbType]],"Miles",{spinner:true});
  o.appendData(["patweight",["decimal(5,1)","number(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)","decimal(5,1)"][dbType]],"Patient Weight");
  o.appendData(["origin",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Origin");
  o.appendData(["dest",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Destination");
  o.appendData(["purpose",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Purpose");
  o.appendData(["purposestretch",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Purpose of Stretcher");

  o = app.gui.appendDataTable("patcharge","Copayments","Copayment","patient:patientid");
  o.dbiScriptProperties.dataOrder = "chargedttm desc";
  o.appendData(["chargedttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date Charged");
  o.appendSelect("descriptionid","Description",["dfnmst","PATCHARGE","DESCRIPTIONID"],{allowNew:true});
  o.appendData(["amount",["money","numeric(19,4)","money","numeric(19,4)","numeric(19,4)","numeric(19,4)","money"][dbType]],"Amount");

  o = app.gui.appendDataTable("patahst","Allergies","Allergy","patient:patientid",{drop:false});
  o.dbiScriptProperties.dataOrder = "detddttm desc";
  o.appendData(["detddttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date Diagnosed");
  o.appendQuickpick("allergyid","Description",["dfnmst","ALLERGYMST","PID"],{allowNew:true,isRequired:true});

  o = app.gui.appendDataTable("patdhst","Medications","Medication","patient:patientid",{drop:false});
  o.dbiScriptProperties.dataOrder = "effdttm desc";
  o.appendData(["effdttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date Prescribed");
  o.appendQuickpick("drugid","Description",["dfnmst","DRUGMST","PID"],{allowNew:true,ignoreCase:true,isRequired:true});
  o.appendData(["dosage",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],"Dosage");
  o.appendData(["dispense",["varchar(15)","varchar2(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)","varchar(15)"][dbType]],"Dispense");
  o.appendData(["refill",["tinyint","int","tinyint","tinyint unsigned","smallint","smallint","tinyint"][dbType]],"Refill");
  o.appendBoolean("selectcode","Select Code");
  o.appendData(["sig",["longtext","varchar2(4000)","text","longtext","text","long varchar","long varchar"][dbType]],"Sig");

  o = app.gui.appendDataTable("tranprc","Procedures","Procedure","trandtl:trandtlid",1);
  o.dbiScriptProperties.dataOrder = "servtodttm desc";
  o.appendData(["servtodttm",["datetime","timestamp","datetime","datetime","timestamp","timestamp","timestamp"][dbType]],"Date of Service");
  o.appendQuickpick("prcmstid","Procedure","prcmst");
  o.appendMoney(["chargeins",["money","numeric(19,4)","money","numeric(19,4)","numeric(19,4)","numeric(19,4)","money"][dbType]],"Insurance");
  o.appendMoney(["chargepat",["money","numeric(19,4)","money","numeric(19,4)","numeric(19,4)","numeric(19,4)","money"][dbType]],"Patient");
  o.appendMoney("charge","Total Charge");

  o = app.gui.addSystemTable("sysparam","System");
  o.appendData("taxrate","Tax Rate",{decimals:4});

}

// note: validate & verify arguments: s - current value, t - original value, o - all current field values, p - all original field values

function format_name(s,t,u) {return s + ", " + t + (u?" " + u + ".":"");}

var patient_attorneyid_format=format_name, patient_rdrmstid_format0=format_name, patient_refpatientid_format=format_name, patient_sdrmstid_format=format_name, policymst_patientid_format=format_name;
var patient_name_format=format_name, rdrmst_name_format=format_name; // display groups

//function patient_fname_validate(){return"test";}
//function patient_fname_verify(){return"Testing.";}
function patient_button1_onclick(o) {window.open("http://maps.google.com/maps?q="+(o.address1+"+"+o.city+"+"+o.state).replace(/ /g,"+"));}
//function patient_gender_validate() {return"test"}
//function patient_gender_verify(s,t,o,p) {return "Just testing.";}
//function patient_icd9ids_validate(){return"test test test test test test test test test test test test test test test test test test test test test test test test test test test test test test"}
function patient_icons_calculate(o) {var a=[],p=/a/i;if(p.test(o.lname))a.push(0);if(p.test(o.address1))a.push(1);if(p.test(o.city))a.push(2);if(p.test(o.state))a.push(3);return a;}
function patient_inactvdttm_updateValue(s,t,i,j,k){if(s == "patient" && t == "inactv")return k?new Date:undefined; return null;}
//function patient_lname_style(b,i/* 0 = even, 1 = odd, 2 = selected */,s) {if(b)return {background:/b/i.test(s)?"blue":"red"};else if(i==2)return /b/i.test(s)?{background:""}:undefined;var o = {color:/c/i.test(s)?"blue":"",fontStyle:/o/i.test(s)?"italic":""}; if(/b/i.test(s))o.background = "url(../images/t02.png)"; return o;}
//function patient_lname_validate(s,t,o,p) {return count++<2?"Just testing.":"";}
//function patient_lname_verify(s,t,o,p) {return "Just testing.";}
function patient_lstmensdttm_isDisplayed(o) {return o.gender == "F";}
//function patient_notes_validate(){return"test"}
//function patient_phonenumbers_isDisplayed(o) {return o.gender == "F";}
//function patient_relatetoid_verify(s,t,o,p) {return "Just testing.";}
function patient_rdrmstid_format1(s,t,u){return t + " " + (u?u + ". ":"") + s;}
//function patient_notes_validate(){return"Testing.";}
//function patient_notes_verify(){return"Testing.";}

function patient_stockPrice_calculateHttpData(o){return {s:o.stock,f:"l1"};}
function patient_stockPrice_processResponse(s){var lastPrice = parseFloat(s);return isNaN(lastPrice) ? "" : "$" + lastPrice.toFixed(2);}

function patient_row_drilldownStyle(b,i,o) {}
//function patient_row_validateDelete(o,p,i,q) {return i>0?"Deleting patients with child records is not allowed.":"";}

function insmst_contact_onfocus() {return;list(this.originalValue("patient.fname"),this.focusValue("patient.fname"),this.currentValue("patient.fname"));}
function insmst_email_setSubject(o) {return "Attn: Claim Office #" + o.claimoffice;}
//function insmst_email_verify() {return"test";}

function policymst_row_drilldownCaptionStyle(b,i,o) {return b?{background:"blue",color:"yellow"}:U;}
function policymst_coverage_validate() {return;list(arguments,arguments[L]);}

//function patpolicymst_row_drilldownCaptionStyle(b,i,o,p){return {background:p.patient.gender=="M"?"blue":"yellow"};}
//function patpolicymst_typeid_validate(s,t,o,p,q){list(q);}

function trandtl_servfrdttm_newValue() {return new Date;}
function trandtl_total_parameters() {var o=new Date(2012,0,1),p=new Date(2013,0,1);return {startOf2012:o,startOf2013:p};}
//function trandtl_notes_setRows(){return count+++5;}

function trandtl2_isDisplayed(o) {return o.trandtl.aa}

function patdhst_effdttm_newValue() {return new Date;}

function trandtl_total_parameters() {var o=new Date,p=new Date(o.getFullYear(),0,1),q=new Date(p - 1);return {startOfCurrentYear:p,endOfLastYear:q};}

function tranprc_charge_calculate(o) {return o.chargeins + o.chargepat;}
function tranprc_chargeins_validate(s) {return s > 100000 ? "Charge cannot exceed $100,000" : "";}
function tranprc_chargeins_verify(s) {return s > 10000 ? "Charge exceeds $10,000" : "";}
